searchNodes=[{"doc":"Provides a high-level interface to an implementation of the HomeKit Accessory Protocol, allowing an application to present any number of services &amp; characteristics of those services to an iOS HomeKit controllerA typical use case is as follows:hap_server_config = HAP.build_accessory_server( name: &quot;My HAP Demo Device&quot;, model: &quot;HAP Demo Device&quot;, identifier: &quot;11:22:33:44:12:66&quot;, accessory_type: 5, accessories: [ HAP.build_accessory( name: &quot;HAP Lightbulb&quot;, model: &quot;HAP Lightbulb&quot;, manufacturer: &quot;HAP Inc.&quot;, serial_number: &quot;123456&quot;, firmware_revision: &quot;1.0&quot;, services: [ HAP.Services.LightBulb.build_service(value_store_mod, value_store_opts) ] ) ] ) children = [ {HAP, hap_server_config} ] Supervisor.start_link(children, opts) ...","ref":"HAP.html","title":"HAP","type":"module"},{"doc":"Builds an instance of HAP.Accessory based on the provided information. The services passed in services will be included in the created accessory's list of services, as well as an instance of Services.AccessoryInformation and Services.ProtocolInformation based on the extra provided metadata. This function is typically called within a call to HAP.build_accessory_server/1 as in the example at the top of this file.Supported fields include:name: The name to assign to this accessory, for example 'Ceiling Fan'model: The model name to assign to this accessory, for example 'FanCo Whisper III'manufacturer: The manufacturer of this accessory, for example 'FanCo'serial_number: The serial number of this accessory, for example '0012345'firmware_revision: The firmware revision of this accessory, for example '1.0'services: A list of services to include in this accessory","ref":"HAP.html#build_accessory/1","title":"HAP.build_accessory/1","type":"function"},{"doc":"Builds an instance of HAP.AccessoryServer based on the provided information. This function is typically called to build the input to a HAP.start_link/1 call as in the example at the top of this file.Supported fields include:name: The name to assign to this device, for example 'HAP Bridge'model: The model name to assign to this accessory, for example 'HAP Bridge'identifier: A unique identifier string in the form &quot;AA:BB:CC:DD:EE:FF&quot;pairing_code: A pairing code of the form 123-45-678 to be used for pairing. If not specified one will be defined dynamically.setup_id: A 4 character string used as part of the accessory discovery process. If not specified one will be defined dynamically.display_module: An implementation of HAP.Display used to present pairing and other information to the user. If not specified then HAP.ConsoleDisplay will be useddata_path: The path to where HAP will store its internal data. Will be created if it does not exist. If not specified, hap_data is used.accessory_type: A HAP specified value indicating the primary function of this device. See HAP.AccessoryServer.accessory_type/0 for detailsaccessories: A list of accessories to include in this accessory server","ref":"HAP.html#build_accessory_server/1","title":"HAP.build_accessory_server/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"HAP.html#child_spec/1","title":"HAP.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1.","ref":"HAP.html#init/1","title":"HAP.init/1","type":"function"},{"doc":"Starts a HAP instance based on the passed config","ref":"HAP.html#start_link/1","title":"HAP.start_link/1","type":"function"},{"doc":"Represents a single accessory object, containing a number of services","ref":"HAP.Accessory.html","title":"HAP.Accessory","type":"module"},{"doc":"Represents an accessory consisting of a number of services","ref":"HAP.Accessory.html#t:t/0","title":"HAP.Accessory.t/0","type":"type"},{"doc":"Represents a top-level HAP instance configuration","ref":"HAP.AccessoryServer.html","title":"HAP.AccessoryServer","type":"module"},{"doc":"A unique identifier string in the form &quot;AA:BB:CC:DD:EE:FF&quot;","ref":"HAP.AccessoryServer.html#t:accessory_identifier/0","title":"HAP.AccessoryServer.accessory_identifier/0","type":"type"},{"doc":"A HAP specified value indicating the primary function of this device as found in Section 13 of Apple's HomeKit Accessory Protocol Specification. Valid values include:OtherBridgeFanGarageLightbulbDoor LockOutletSwitchThermostatSensorSecurity SystemDoorWindowWindow CoveringProgrammable SwitchRange ExtenderIP CameraVideo Door BellAir PurifierHeaterAir ConditionerHumidifierDehumidifierSprinklerFaucetShower SystemRemote","ref":"HAP.AccessoryServer.html#t:accessory_type/0","title":"HAP.AccessoryServer.accessory_type/0","type":"type"},{"doc":"The model of an accessory server","ref":"HAP.AccessoryServer.html#t:model/0","title":"HAP.AccessoryServer.model/0","type":"type"},{"doc":"The name of an accessory server","ref":"HAP.AccessoryServer.html#t:name/0","title":"HAP.AccessoryServer.name/0","type":"type"},{"doc":"A pairing code of the form 123-45-678","ref":"HAP.AccessoryServer.html#t:pairing_code/0","title":"HAP.AccessoryServer.pairing_code/0","type":"type"},{"doc":"A pairing URL suitable for display in a QR code","ref":"HAP.AccessoryServer.html#t:pairing_url/0","title":"HAP.AccessoryServer.pairing_url/0","type":"type"},{"doc":"Represents an accessory server consisting of a number of accessories","ref":"HAP.AccessoryServer.html#t:t/0","title":"HAP.AccessoryServer.t/0","type":"type"},{"doc":"Holds the top-level state of a HAP accessory server","ref":"HAP.AccessoryServerManager.html","title":"HAP.AccessoryServerManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"HAP.AccessoryServerManager.html#child_spec/1","title":"HAP.AccessoryServerManager.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"HAP.AccessoryServerManager.html#init/1","title":"HAP.AccessoryServerManager.init/1","type":"function"},{"doc":"","ref":"HAP.AccessoryServerManager.html#start_link/1","title":"HAP.AccessoryServerManager.start_link/1","type":"function"},{"doc":"Represents a single characteristic optionally backed by an instance of ValueStore","ref":"HAP.Characteristic.html","title":"HAP.Characteristic","type":"module"},{"doc":"The format of a characteristic as defined in Table 6.5 of Apple's HomeKit Accessory Protocol Specification. One of bool, uint8, uint16, uint32, uint64, int, float, string, tlv8, or data","ref":"HAP.Characteristic.html#t:format/0","title":"HAP.Characteristic.format/0","type":"type"},{"doc":"A permission of a characteristic as defined in Table 6.4 of Apple's HomeKit Accessory Protocol Specification. One of pr, pw, ev, aa, tw, hd, or wr","ref":"HAP.Characteristic.html#t:perm/0","title":"HAP.Characteristic.perm/0","type":"type"},{"doc":"Represents a single characteristic optionally backed by an instance of ValueStore","ref":"HAP.Characteristic.html#t:t/0","title":"HAP.Characteristic.t/0","type":"type"},{"doc":"The type of a characteristic as defined in Section 6.6.1 of Apple's HomeKit Accessory Protocol Specification.","ref":"HAP.Characteristic.html#t:type/0","title":"HAP.Characteristic.type/0","type":"type"},{"doc":"The value of a characrteristic","ref":"HAP.Characteristic.html#t:value/0","title":"HAP.Characteristic.value/0","type":"type"},{"doc":"Factory for the public.hap.characteristic.firmware.revision characteristic","ref":"HAP.Characteristics.FirmwareRevision.html","title":"HAP.Characteristics.FirmwareRevision","type":"module"},{"doc":"","ref":"HAP.Characteristics.FirmwareRevision.html#build_characteristic/1","title":"HAP.Characteristics.FirmwareRevision.build_characteristic/1","type":"function"},{"doc":"Factory for the public.hap.characteristic.identify characteristic","ref":"HAP.Characteristics.Identify.html","title":"HAP.Characteristics.Identify","type":"module"},{"doc":"","ref":"HAP.Characteristics.Identify.html#build_characteristic/2","title":"HAP.Characteristics.Identify.build_characteristic/2","type":"function"},{"doc":"Factory for the public.hap.characteristic.manufacturer characteristic","ref":"HAP.Characteristics.Manufacturer.html","title":"HAP.Characteristics.Manufacturer","type":"module"},{"doc":"","ref":"HAP.Characteristics.Manufacturer.html#build_characteristic/1","title":"HAP.Characteristics.Manufacturer.build_characteristic/1","type":"function"},{"doc":"Factory for the public.hap.characteristic.model characteristic","ref":"HAP.Characteristics.Model.html","title":"HAP.Characteristics.Model","type":"module"},{"doc":"","ref":"HAP.Characteristics.Model.html#build_characteristic/1","title":"HAP.Characteristics.Model.build_characteristic/1","type":"function"},{"doc":"Factory for the public.hap.characteristic.name characteristic","ref":"HAP.Characteristics.Name.html","title":"HAP.Characteristics.Name","type":"module"},{"doc":"","ref":"HAP.Characteristics.Name.html#build_characteristic/1","title":"HAP.Characteristics.Name.build_characteristic/1","type":"function"},{"doc":"Factory for the public.hap.characteristic.on characteristic","ref":"HAP.Characteristics.On.html","title":"HAP.Characteristics.On","type":"module"},{"doc":"","ref":"HAP.Characteristics.On.html#build_characteristic/2","title":"HAP.Characteristics.On.build_characteristic/2","type":"function"},{"doc":"Factory for the public.hap.characteristic.serial-number characteristic","ref":"HAP.Characteristics.SerialNumber.html","title":"HAP.Characteristics.SerialNumber","type":"module"},{"doc":"","ref":"HAP.Characteristics.SerialNumber.html#build_characteristic/1","title":"HAP.Characteristics.SerialNumber.build_characteristic/1","type":"function"},{"doc":"Factory for the public.hap.characteristic.version characteristic","ref":"HAP.Characteristics.Version.html","title":"HAP.Characteristics.Version","type":"module"},{"doc":"","ref":"HAP.Characteristics.Version.html#build_characteristic/1","title":"HAP.Characteristics.Version.build_characteristic/1","type":"function"},{"doc":"Defines the HTTP interface for a HomeKit Accessory which may only be accseed over a non-encrpyted channel","ref":"HAP.CleartextHTTPServer.html","title":"HAP.CleartextHTTPServer","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"HAP.CleartextHTTPServer.html#call/2","title":"HAP.CleartextHTTPServer.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"HAP.CleartextHTTPServer.html#init/1","title":"HAP.CleartextHTTPServer.init/1","type":"function"},{"doc":"A simple console based implementation of the HAP.Display behaviour","ref":"HAP.ConsoleDisplay.html","title":"HAP.ConsoleDisplay","type":"module"},{"doc":"Functions to encrypt/tag and decrypt/verify using the chacha20_poly1305 cipher","ref":"HAP.Crypto.ChaCha20.html","title":"HAP.Crypto.ChaCha20","type":"module"},{"doc":"Takes a binary containing encrypted data followed by a 16 byte tag, verifies the tag and decrypts the resultant data using the given key and nonce. Can take optional AAD data which is authenticated under the auth_tag but not encrypted. Returns {:ok, plaintext} or {:error, message}","ref":"HAP.Crypto.ChaCha20.html#decrypt_and_verify/4","title":"HAP.Crypto.ChaCha20.decrypt_and_verify/4","type":"function"},{"doc":"Takes a plaintext binary and encrypts &amp; tags it using the given key &amp; nonce. Optionally takes AAD data which is authenticated under the auth tag but not included in the returned binary (it is up to the caller to convey the AAD to their counterparty). Returns {:ok, encrypted_data &lt;&gt; auth_tag}","ref":"HAP.Crypto.ChaCha20.html#encrypt_and_tag/4","title":"HAP.Crypto.ChaCha20.encrypt_and_tag/4","type":"function"},{"doc":"","ref":"HAP.Crypto.ChaCha20.html#t:aad/0","title":"HAP.Crypto.ChaCha20.aad/0","type":"type"},{"doc":"","ref":"HAP.Crypto.ChaCha20.html#t:ciphertext_with_authdata/0","title":"HAP.Crypto.ChaCha20.ciphertext_with_authdata/0","type":"type"},{"doc":"","ref":"HAP.Crypto.ChaCha20.html#t:key/0","title":"HAP.Crypto.ChaCha20.key/0","type":"type"},{"doc":"","ref":"HAP.Crypto.ChaCha20.html#t:nonce/0","title":"HAP.Crypto.ChaCha20.nonce/0","type":"type"},{"doc":"","ref":"HAP.Crypto.ChaCha20.html#t:plaintext/0","title":"HAP.Crypto.ChaCha20.plaintext/0","type":"type"},{"doc":"Functions to work with Elliptic Curve Diffie-Hellman shared secret generation","ref":"HAP.Crypto.ECDH.html","title":"HAP.Crypto.ECDH","type":"module"},{"doc":"Computes a shared secret from the counterpary's public key and our private key, using the x25519 curve.Returns {:ok, shared secret}","ref":"HAP.Crypto.ECDH.html#compute_key/2","title":"HAP.Crypto.ECDH.compute_key/2","type":"function"},{"doc":"Generates a new ECDH key pair using the x25519 curve.Returns {:ok, public_key, provate_key}","ref":"HAP.Crypto.ECDH.html#key_gen/0","title":"HAP.Crypto.ECDH.key_gen/0","type":"function"},{"doc":"","ref":"HAP.Crypto.ECDH.html#t:private_key/0","title":"HAP.Crypto.ECDH.private_key/0","type":"type"},{"doc":"","ref":"HAP.Crypto.ECDH.html#t:public_key/0","title":"HAP.Crypto.ECDH.public_key/0","type":"type"},{"doc":"","ref":"HAP.Crypto.ECDH.html#t:shared_secret/0","title":"HAP.Crypto.ECDH.shared_secret/0","type":"type"},{"doc":"Functions to generate keys, sign &amp; verify messages using Elliptic Curve Signatures","ref":"HAP.Crypto.EDDSA.html","title":"HAP.Crypto.EDDSA","type":"module"},{"doc":"Generates a new signing key pair using the ed25519 signature scheme.Returns {:ok, public_key, private_key}","ref":"HAP.Crypto.EDDSA.html#key_gen/0","title":"HAP.Crypto.EDDSA.key_gen/0","type":"function"},{"doc":"Signs the given message with the given ed25519 private key.Returns {:ok, signature}","ref":"HAP.Crypto.EDDSA.html#sign/2","title":"HAP.Crypto.EDDSA.sign/2","type":"function"},{"doc":"Verifies that the given signature signs the given message under the key specified.Returns {:ok, true} or {:ok, false}","ref":"HAP.Crypto.EDDSA.html#verify/3","title":"HAP.Crypto.EDDSA.verify/3","type":"function"},{"doc":"","ref":"HAP.Crypto.EDDSA.html#t:plaintext/0","title":"HAP.Crypto.EDDSA.plaintext/0","type":"type"},{"doc":"","ref":"HAP.Crypto.EDDSA.html#t:private_key/0","title":"HAP.Crypto.EDDSA.private_key/0","type":"type"},{"doc":"","ref":"HAP.Crypto.EDDSA.html#t:public_key/0","title":"HAP.Crypto.EDDSA.public_key/0","type":"type"},{"doc":"","ref":"HAP.Crypto.EDDSA.html#t:signature/0","title":"HAP.Crypto.EDDSA.signature/0","type":"type"},{"doc":"Functions to help with key derivation","ref":"HAP.Crypto.HKDF.html","title":"HAP.Crypto.HKDF","type":"module"},{"doc":"Generates a session key from provided parameters. Uses the SHA-512 as HMACReturns {:ok, session_key}","ref":"HAP.Crypto.HKDF.html#generate/3","title":"HAP.Crypto.HKDF.generate/3","type":"function"},{"doc":"","ref":"HAP.Crypto.HKDF.html#t:ikm/0","title":"HAP.Crypto.HKDF.ikm/0","type":"type"},{"doc":"","ref":"HAP.Crypto.HKDF.html#t:info/0","title":"HAP.Crypto.HKDF.info/0","type":"type"},{"doc":"","ref":"HAP.Crypto.HKDF.html#t:salt/0","title":"HAP.Crypto.HKDF.salt/0","type":"type"},{"doc":"","ref":"HAP.Crypto.HKDF.html#t:session_key/0","title":"HAP.Crypto.HKDF.session_key/0","type":"type"},{"doc":"Simple wrapper around Erlang's :crypto.hash() function","ref":"HAP.Crypto.SHA512.html","title":"HAP.Crypto.SHA512","type":"module"},{"doc":"Returns the SHA-512 has of the given message.Returns the hash directly (not contained in a success tuple)","ref":"HAP.Crypto.SHA512.html#hash/1","title":"HAP.Crypto.SHA512.hash/1","type":"function"},{"doc":"","ref":"HAP.Crypto.SHA512.html#t:hash/0","title":"HAP.Crypto.SHA512.hash/0","type":"type"},{"doc":"","ref":"HAP.Crypto.SHA512.html#t:message/0","title":"HAP.Crypto.SHA512.message/0","type":"type"},{"doc":"Implements the various steps within the Stanford Remote Password (version 6a) flow","ref":"HAP.Crypto.SRP6A.html","title":"HAP.Crypto.SRP6A","type":"module"},{"doc":"","ref":"HAP.Crypto.SRP6A.html#auth_context/1","title":"HAP.Crypto.SRP6A.auth_context/1","type":"function"},{"doc":"","ref":"HAP.Crypto.SRP6A.html#client/3","title":"HAP.Crypto.SRP6A.client/3","type":"function"},{"doc":"","ref":"HAP.Crypto.SRP6A.html#shared_key/4","title":"HAP.Crypto.SRP6A.shared_key/4","type":"function"},{"doc":"","ref":"HAP.Crypto.SRP6A.html#verifier/2","title":"HAP.Crypto.SRP6A.verifier/2","type":"function"},{"doc":"Provides functions to define &amp; update a HAP.Accessory advertisement via multicast DNS according to Section 6 of Apple's HomeKit Accessory Protocol Specification.","ref":"HAP.Discovery.html","title":"HAP.Discovery","type":"module"},{"doc":"Centralized functions for non-logging related display functionality. Applications which use HAP may provide their own implementation of this behaviour as an argument to HAP.build_accessory_server/1. If no such implementation is provided HAP uses a default console based implementation found at HAP.ConsoleDisplay","ref":"HAP.Display.html","title":"HAP.Display","type":"behaviour"},{"doc":"Stop displaying any currently displayed pairing information to the user. This is most commonly because a pairing has been established with a controller","ref":"HAP.Display.html#c:clear_pairing_code/0","title":"HAP.Display.clear_pairing_code/0","type":"callback"},{"doc":"Display a notification to the user containing information on how to pair with this accessory server. The QR code often seen on HomeKit devices to facilitate pairing contains the value of pairing_url; see HAP.ConsoleDisplay for an example of how to display it to the user.","ref":"HAP.Display.html#c:display_pairing_code/3","title":"HAP.Display.display_pairing_code/3","type":"callback"},{"doc":"Display a notification to the user that identifies the named device or accessory. This comes from a user request within the Home app to identify the given device or accessory.","ref":"HAP.Display.html#c:identify/1","title":"HAP.Display.identify/1","type":"callback"},{"doc":"Defines the HTTP interface for a HomeKit Accessory which may only be accessed over a secure channel","ref":"HAP.EncryptedHTTPServer.html","title":"HAP.EncryptedHTTPServer","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"HAP.EncryptedHTTPServer.html#call/2","title":"HAP.EncryptedHTTPServer.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"HAP.EncryptedHTTPServer.html#init/1","title":"HAP.EncryptedHTTPServer.init/1","type":"function"},{"doc":"Implements cleartext TCP transport with optional chacha20_poly1305 encryption as mandated by section 6.5.2 of the HomeKit Accessory Protocol specification","ref":"HAP.HAPSessionTransport.html","title":"HAP.HAPSessionTransport","type":"module"},{"doc":"Helpful in tests when we need to act as the iOS Controller in a HAP Session","ref":"HAP.HAPSessionTransport.html#connect/3","title":"HAP.HAPSessionTransport.connect/3","type":"function"},{"doc":"Returns true iff the current process is in an encrypted session","ref":"HAP.HAPSessionTransport.html#encrypted_session?/0","title":"HAP.HAPSessionTransport.encrypted_session?/0","type":"function"},{"doc":"Defines the HTTP interface for a HomeKit Accessory","ref":"HAP.HTTPServer.html","title":"HAP.HTTPServer","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"HAP.HTTPServer.html#call/2","title":"HAP.HTTPServer.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"HAP.HTTPServer.html#init/1","title":"HAP.HTTPServer.init/1","type":"function"},{"doc":"Functions to map IIDs to/from service and characteristic indexes.Service &amp; characteristic IDs are each encoded as 8 bits within the IID. This makes it deterministic to extract the service and characteristic index from a given IID. This provides 256 possible service indices &amp; 255 possible characteristic indices, which exceeds the limit of 100 services and characteristics as defined in 6.3.1 and 6.3.2 of the HAP specification.Since IIDs are defined on the range [1, 18446744073709551615] per section 2.6.1 of the HAP specification, we set the lowest bit of the IID to 1, this allowing for service and characteristic indices of 0. As a consequence, any valid IID generated by this module will be in the range [1, 65536]. We also add 1 to the indicated characateristic index when populating the IID, reserving a characteristic index of 0 to represent service IIDs. This arrangement has the property that the IID for a service index of 0 is encoded as a value of 1, which the HAP protocol requires to represent the accessory information service.","ref":"HAP.IID.html","title":"HAP.IID","type":"module"},{"doc":"Implements the Pair Setup flow described in Apple's HomeKit Accessory Protocol Specification. Since Pair Setup is a singleton operation, this is implemented as a named GenServer","ref":"HAP.PairSetup.html","title":"HAP.PairSetup","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"HAP.PairSetup.html#child_spec/1","title":"HAP.PairSetup.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"HAP.PairSetup.html#init/1","title":"HAP.PairSetup.init/1","type":"function"},{"doc":"","ref":"HAP.PairSetup.html#start_link/1","title":"HAP.PairSetup.start_link/1","type":"function"},{"doc":"Implements the Pair Verify flow described in Apple's HomeKit Accessory Protocol Specification.","ref":"HAP.PairVerify.html","title":"HAP.PairVerify","type":"module"},{"doc":"","ref":"HAP.PairVerify.html#init/0","title":"HAP.PairVerify.init/0","type":"function"},{"doc":"Implements the Add / Remove / List Pairings flows described in Apple's HomeKit Accessory Protocol Specification.","ref":"HAP.Pairings.html","title":"HAP.Pairings","type":"module"},{"doc":"Encapsulates a simple persistent key-value store","ref":"HAP.PersistentStorage.html","title":"HAP.PersistentStorage","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"HAP.PersistentStorage.html#child_spec/1","title":"HAP.PersistentStorage.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"HAP.PersistentStorage.html#init/1","title":"HAP.PersistentStorage.init/1","type":"function"},{"doc":"","ref":"HAP.PersistentStorage.html#start_link/1","title":"HAP.PersistentStorage.start_link/1","type":"function"},{"doc":"Represents a single service, containing a number of characteristics","ref":"HAP.Service.html","title":"HAP.Service","type":"module"},{"doc":"Represents a service of a given type, containing a number of characteristics","ref":"HAP.Service.html#t:t/0","title":"HAP.Service.t/0","type":"type"},{"doc":"The type of a service as defined in Section 6.6.1 of Apple's HomeKit Accessory Protocol Specification.","ref":"HAP.Service.html#t:type/0","title":"HAP.Service.type/0","type":"type"},{"doc":"Factory for the public.hap.service.accessory-information service","ref":"HAP.Services.AccessoryInformation.html","title":"HAP.Services.AccessoryInformation","type":"module"},{"doc":"","ref":"HAP.Services.AccessoryInformation.html#build_service/1","title":"HAP.Services.AccessoryInformation.build_service/1","type":"function"},{"doc":"Factory for the public.hap.service.lightbulb service","ref":"HAP.Services.LightBulb.html","title":"HAP.Services.LightBulb","type":"module"},{"doc":"","ref":"HAP.Services.LightBulb.html#build_service/2","title":"HAP.Services.LightBulb.build_service/2","type":"function"},{"doc":"Factory for the public.hap.service.protocol.information.service service","ref":"HAP.Services.ProtocolInformation.html","title":"HAP.Services.ProtocolInformation","type":"module"},{"doc":"","ref":"HAP.Services.ProtocolInformation.html#build_service/1","title":"HAP.Services.ProtocolInformation.build_service/1","type":"function"},{"doc":"Provides functions to encode a map or keyword list into a TLV binary as described in Apple's HomeKit Accessory Protocol Specification.","ref":"HAP.TLVEncoder.html","title":"HAP.TLVEncoder","type":"module"},{"doc":"Converts the provided map or keyword list into a TLV binary","ref":"HAP.TLVEncoder.html#to_binary/1","title":"HAP.TLVEncoder.to_binary/1","type":"function"},{"doc":"A Plug.Parsers compliant parser for TLV payloads as described in the Appendix of Apple's HomeKit Accessory Protocol Specification.","ref":"HAP.TLVParser.html","title":"HAP.TLVParser","type":"module"},{"doc":"Parses a TLV binary into a map (does not allow for repeating keys","ref":"HAP.TLVParser.html#parse_tlv/1","title":"HAP.TLVParser.parse_tlv/1","type":"function"},{"doc":"Parses a TLV binary into a keyword list (allows for repeating keys","ref":"HAP.TLVParser.html#parse_tlv_as_keyword/1","title":"HAP.TLVParser.parse_tlv_as_keyword/1","type":"function"},{"doc":"Defines the behaviour required of a module that wishes to act as the backing data store for a given HomeKit characteristic","ref":"HAP.ValueStore.html","title":"HAP.ValueStore","type":"behaviour"},{"doc":"Return the value of a value hosted by this value store. The passed list of opts is as specified in the hosting HAP.Configuration and can be used to distinguish a particular value within a larger value store (perhaps by GPIO pin or similar)Returns the value stored by this value store","ref":"HAP.ValueStore.html#c:get_value/1","title":"HAP.ValueStore.get_value/1","type":"callback"},{"doc":"Sets the value of a value hosted by this value store. The passed list of opts is as specified in the hosting HAP.Configuration and can be used to distinguish a particular value within a larger value store (perhaps by GPIO pin or similar)Returns :ok or {:error, reason}","ref":"HAP.ValueStore.html#c:put_value/2","title":"HAP.ValueStore.put_value/2","type":"callback"},{"doc":"","ref":"HAP.ValueStore.html#t:opts/0","title":"HAP.ValueStore.opts/0","type":"type"},{"doc":"","ref":"HAP.ValueStore.html#t:t/0","title":"HAP.ValueStore.t/0","type":"type"}]